#!/usr/bin/env python3
import sys, pickle, hmac, hashlib

class Dog:
    def __init__(self, name):
        self.name = name

    def bark(self):
        print("{0}: {1}".format(self.name, "Hau!"))

def secure_restore(file_name):
    with open(file_name, "rb") as file:
        content = file.read()
        file_signature = content[:32]
        serialized = content[32:]
        signature = hmac.new(b"Ais4lee%qu", serialized, hashlib.sha256).digest()
        if hmac.compare_digest(file_signature, signature):
            return pickle.loads(serialized)
        else:
            return Dog("Puszek")

if __name__ == "__main__":
    if len(sys.argv) == 2:
        dog = secure_restore(sys.argv[1])
        dog.bark()
