#!/usr/bin/env python3
import sys, pickle, hmac, hashlib

class Dog:
    def __init__(self, name):
        self.name = name

    def bark(self):
        print("{0}: {1}".format(self.name, "Hau!"))

def secure_save(file_name, dog):
    serialized = pickle.dumps(dog)
    signature = hmac.new(b"Ais4lee%qu", serialized, hashlib.sha256).digest()
    with open(file_name, "wb") as file:
        file.write(signature+serialized)

if __name__ == "__main__":
    dog = Dog("Reks")
    dog.bark()
    if len(sys.argv) == 2:
        secure_save(sys.argv[1], dog)
